# -*- coding:Utf-8 -*-
#!/usr/bin/python

# \copyleft Denis LE FUR \copyright
# This work may be distributed and/or mofified under the conditions
# or the LaTeX Project Public Licence, either v1.3 or (at your option)
# any later version. The latest version is in
#   http://www.latex-project.org/lppl/
# This work consists of the files nuage.py.


import pygtk
pygtk.require("2.0")
import gtk  

import os
import sys
import platform

if platform.system()=="Linux" :
    sys.path.append("../SystemeLinux/")
else :
    sys.path.append("../SystemeWindows/")
from pro_sortie import *


sys.path.append("../Divers/")
from pro_divers import *
from textelibre import *
sys.path.append("../Supplements/Pro-2varstat/")
from supp_nuage import *





class Nuage:



    #-------------------------------------------------------------
    # Initialisations, création de la fenêtre principale
    #-------------------------------------------------------------
    def __init__(self):
        interface = gtk.Builder()
        interface.add_from_file('nuage.glade')
        self.initialisation=True
        self.radiobuttonMetapost = interface.get_object("radiobuttonMetapost")
        self.radiobuttonAsymptote = interface.get_object("radiobuttonAsymptote")
        self.entryListeValeursX = interface.get_object("entryListeValeursX")
        self.entryListeValeursY = interface.get_object("entryListeValeursY")
        self.entryXmin = interface.get_object("entryXmin")
        self.entryXmax = interface.get_object("entryXmax")
        self.entryYmin = interface.get_object("entryYmin")
        self.entryYmax = interface.get_object("entryYmax")
        self.entryUx = interface.get_object("entryUx")
        self.entryUy = interface.get_object("entryUy")
        self.entryLx = interface.get_object("entryLx")
        self.entryLy = interface.get_object("entryLy")
        self.entryGx = interface.get_object("entryGx")
        self.entryGy = interface.get_object("entryGy")
        self.entryNomDR = interface.get_object("entryNomDR")
        self.entryXDR = interface.get_object("entryXDR")
        self.entryNomPM = interface.get_object("entryNomPM")
        self.comboboxCouleurDR = interface.get_object("comboboxCouleurDR")  
        self.comboboxCouleurPM = interface.get_object("comboboxCouleurPM")
        self.comboboxPositionDR = interface.get_object("comboboxPositionDR")
        self.comboboxPositionPM = interface.get_object("comboboxPositionPM")
        self.buttonCompiler = interface.get_object("buttonCompiler")
        self.progressbar = interface.get_object("progressbar")
        self.buttonCodeGraphique = interface.get_object("buttonCodeGraphique")
        self.buttonPdf = interface.get_object("buttonPdf")
        self.textviewCodeProfessor = interface.get_object("textviewCodeProfessor")
        self.textviewSupp = interface.get_object("textviewSupp")
        self.labelEntete = interface.get_object("labelEntete")
        self.checkbuttonTitreGauche = interface.get_object("checkbuttonTitreGauche")
        self.checkbuttonTitreCentre = interface.get_object("checkbuttonTitreCentre")
        self.checkbuttonTitreDroite = interface.get_object("checkbuttonTitreDroite")
        self.checkbuttonCouleurBoite = interface.get_object("checkbuttonCouleurBoite")
        self.checkbuttonDR = interface.get_object("checkbuttonDR")
        self.checkbuttonPM = interface.get_object("checkbuttonPM")
        self.checkbuttonTexteLibre = interface.get_object("checkbuttonTexteLibre")
        self.entryTitreGauche = interface.get_object("entryTitreGauche")
        self.entryTitreCentre = interface.get_object("entryTitreCentre")
        self.entryTitreDroite = interface.get_object("entryTitreDroite")    

        
        #Indique si la compilation est lancée
        self.Etat_Compilation=False
        
        #fenêtre textlibre
        self.TL=Textelibre(self)
        self.TL.windowTL.set_title("Textes supplémentaires")
        self.TL.windowTL.hide()
        
        
        interface.connect_signals(self)
        self.maj_codeprofessor()
        maj_codesupp(self)
        
        #Couleur par défaut : rouge
        self.comboboxCouleurDR.set_active(0)
        self.comboboxCouleurPM.set_active(0)
        
        #Position par défaut : Haut
        self.comboboxPositionDR.set_active(0)
        self.comboboxPositionPM.set_active(0)
        
        #désactivation
        self.comboboxCouleurDR.set_sensitive(False)
        self.comboboxCouleurPM.set_sensitive(False)
        self.comboboxPositionDR.set_sensitive(False)
        self.comboboxPositionPM.set_sensitive(False)
        self.entryXDR.set_sensitive(False)
        self.entryNomDR.set_sensitive(False)
        self.entryNomPM.set_sensitive(False)
        
        self.textviewCodeProfessor.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse(couleurfond))
        self.textviewSupp.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse(couleurfond))

        self.entryTitreGauche.set_sensitive(False)
        self.entryTitreCentre.set_sensitive(False)
        self.entryTitreDroite.set_sensitive(False)
        
        self.initialisation=False


    #-------------------------------------------------------------  
    # Fin de l'application  
    #-------------------------------------------------------------
    def on_windowNuage_destroy(self, widget):
        gtk.main_quit()

    #-------------------------------------------------------------
    # Met à jour le code à insérer
    #-------------------------------------------------------------  
    def maj_codeprofessor(self):
        text_view=self.textviewCodeProfessor
        Texte_Code="\\begin{pro-nuage}{1}\n"
        Texte_Code=Texte_Code+"["
        ListeValeursX=self.entryListeValeursX.get_text()
        ListeValeursX=ListeValeursX.replace('\\','@')
        ListeValeursY=self.entryListeValeursY.get_text()
        ListeValeursY=ListeValeursY.replace('\\','@')
        Xmin=self.entryXmin.get_text()
        Xmin=Xmin.replace('\\','@')
        Xmax=self.entryXmax.get_text()
        Xmax=Xmax.replace('\\','@')
        Ymin=self.entryYmin.get_text()
        Ymin=Ymin.replace('\\','@')
        Ymax=self.entryYmax.get_text()
        Ymax=Ymax.replace('\\','@')
        Ux=self.entryUx.get_text()
        Ux=Ux.replace('\\','@')
        Uy=self.entryUy.get_text()
        Uy=Uy.replace('\\','@')
        Lx=self.entryLx.get_text()
        Lx=Lx.replace('\\','@')
        Ly=self.entryLy.get_text()
        Ly=Ly.replace('\\','@')
        Gx=self.entryGx.get_text()
        Gx=Gx.replace('\\','@') 
        Gy=self.entryGy.get_text()
        Gy=Gy.replace('\\','@') 
        Texte_Code=Texte_Code+ListeValeursX+"],\n"
        Texte_Code=Texte_Code+"["+ListeValeursY+"],\n"
        Texte_Code=Texte_Code+Xmin+","+Xmax+","+Ymin+","+Ymax+",\n"
        Texte_Code=Texte_Code+Ux+","+Uy+",\n"
        Texte_Code=Texte_Code+Lx+","+Ly+",\n"
        Texte_Code=Texte_Code+Gx+","+Gy+",\n"
        Texte_Code=Texte_Code+"// ----------------- début des options\n"
        Texte_Code=Texte_Code+"[\n"
        Options=self.traiter_options()
        Texte_Code=Texte_Code+Options
        Texte_Code=Texte_Code+"]\n"
        Texte_Code=Texte_Code+"// ----------------- fin des options\n"
        Texte_Code=Texte_Code+"\\end{pro-nuage}"
        ecrire_texte_textview(Texte_Code,text_view)




    #-------------------------------------------------------------
    # Mise à jour après des changements dans la définition
    #-------------------------------------------------------------      
    def on_entryListeValeursX_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryListeValeursY_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryXmin_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryXmax_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryYmin_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryYmax_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False 
        
    def on_entryUx_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryUy_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False 
        
    def on_entryLx_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryLy_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryGx_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)  
        self.Etat_Compilation=False
        
    def on_entryGy_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)  
        self.Etat_Compilation=False 

    def on_checkbuttonDR_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonDR.get_active()==True:
            self.comboboxCouleurDR.set_sensitive(True)
            self.comboboxPositionDR.set_sensitive(True)
            self.entryNomDR.set_sensitive(True)
            self.entryXDR.set_sensitive(True)
        else:
            self.comboboxCouleurDR.set_sensitive(False)
            self.comboboxPositionDR.set_sensitive(False)
            self.entryNomDR.set_sensitive(False)
            self.entryXDR.set_sensitive(False)
        self.Etat_Compilation=False
        
    def on_checkbuttonPM_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonPM.get_active()==True:
            self.comboboxCouleurPM.set_sensitive(True)
            self.comboboxPositionPM.set_sensitive(True)
            self.entryNomPM.set_sensitive(True)
        else:
            self.comboboxCouleurPM.set_sensitive(False)
            self.comboboxPositionPM.set_sensitive(False)
            self.entryNomPM.set_sensitive(False)
        self.Etat_Compilation=False 

    def on_checkbuttonTexteLibre_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonTexteLibre.get_active()==True:
            self.TL.windowTL.show_all()
        else:
            self.TL.windowTL.hide()
        self.Etat_Compilation=False
        


    #-------------------------------------------------------------
    # Mise à jour du label du nom de paquet à utiliser
    #-------------------------------------------------------------          
    def on_radiobuttonMetapost_clicked(self,widget):
        self.labelEntete.set_label("Placer dans l\'entête : \\usepackage[xcas]{pro-2varstat}")
        self.Etat_Compilation=False
        
    def on_radiobuttonAsymptote_clicked(self,widget):
        self.labelEntete.set_label("Placer dans l\'entête : \\usepackage[xcas]{pro-asy-2varstat}")      
        self.Etat_Compilation=False
        

    #-------------------------------------------------------------
    # Traitement des options    
    #-------------------------------------------------------------  
    def traiter_options(self):
        Options=""
        if self.checkbuttonTitreGauche.get_active()==True :
           Options="[\"titre-gauche\",\""
           TitreGauche=self.entryTitreGauche.get_text()
           TitreGauche=traiter_texte(TitreGauche)
           Options=Options+TitreGauche
           Options=Options+"\"],\n"
           
        if self.checkbuttonTitreCentre.get_active()==True :
           Options=Options+"[\"titre-centre\",\""
           TitreCentre=self.entryTitreCentre.get_text()
           TitreCentre=traiter_texte(TitreCentre)
           Options=Options+TitreCentre
           Options=Options+"\"],\n" 
           
        if self.checkbuttonTitreDroite.get_active()==True :
           Options=Options+"[\"titre-droite\",\""
           TitreDroite=self.entryTitreDroite.get_text()
           TitreDroite=traiter_texte(TitreDroite)
           Options=Options+TitreGauche
           
        if self.checkbuttonDR.get_active()==True :
            NomDR=self.entryNomDR.get_text()
            NomDR=NomDR.replace('\\','@')
            XDR=self.entryXDR.get_text()
            CouleurDR=self.comboboxCouleurDR.get_active_text()
            CouleurDR=Nom_Couleur(CouleurDR)
            PositionDR=self.comboboxPositionDR.get_active_text()
            PositionDR=Nom_Position(PositionDR)
            Options=Options+"[\"droite-regression\",\""
            Options=Options+CouleurDR 
            Options=Options+"\"],\n"  
            Options=Options+"[\"texte-courbe\","+XDR+",\""+NomDR+"\",\""+PositionDR+"\",\""+CouleurDR+"\"],\n"
            
        if self.checkbuttonPM.get_active()==True :
            NomPM=self.entryNomPM.get_text()
            NomPM=NomPM.replace('\\','@')
            CouleurPM=self.comboboxCouleurPM.get_active_text()
            CouleurPM=Nom_Couleur(CouleurPM)
            PositionPM=self.comboboxPositionPM.get_active_text()
            PositionPM=Nom_Position(PositionPM)
            Options=Options+"[\"point-moyen\",\""+NomPM+"\",\""+PositionPM+"\",\""+CouleurPM
            Options=Options+"\",[\"xy\",\"$@overline{x}$\",\"$@overline{y}$\"]],\n"
               
        Options=Options+self.TL.Texte_Libre
        Options=Options+"[\"rien\"]\n"
        return Options

    #-------------------------------------------------------------
    # Mise à jour suite au traitement des options   
    #-------------------------------------------------------------          
    def on_checkbuttonTitreGauche_clicked(self,widget):
        if self.checkbuttonTitreGauche.get_active()==False :
            self.entryTitreGauche.set_sensitive(False)
        else :
            self.entryTitreGauche.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False

    def on_checkbuttonTitreCentre_clicked(self,widget):
        if self.checkbuttonTitreCentre.get_active()==False :
            self.entryTitreCentre.set_sensitive(False)
        else :
            self.entryTitreCentre.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False
            
    def on_checkbuttonTitreDroite_clicked(self,widget):
        if self.checkbuttonTitreDroite.get_active()==False :
            self.entryTitreDroite.set_sensitive(False)
        else :
            self.entryTitreDroite.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False
        
    def on_entryTitreGauche_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False

    def on_entryTitreCentre_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False 

    def on_entryTitreDroite_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False
        
    def on_comboboxCouleurDR_changed(self,widget):  
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False
        
    def on_comboboxCouleurPM_changed(self,widget):  
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False

    def on_comboboxPositionDR_changed(self,widget): 
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False 
        
    def on_comboboxPositionPM_changed(self,widget): 
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False 
            
    def on_entryXDR_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False 
        
    def on_entryNomDR_changed(self,widget): 
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False 
        
    def on_entryNomPM_changed(self,widget): 
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False     
        
        

    #-------------------------------------------------------------
    # lancement de la compilation   
    #-------------------------------------------------------------  
    def on_buttonTester_pressed(self,widget):
        self.progressbar.set_text("en cours...")
        
    def on_buttonTester_released(self,widget):
        # création du fichier codeprofessor à partir du buffer
        text_buffer=self.textviewCodeProfessor.get_buffer()
        start_iter = text_buffer.get_start_iter()
        end_iter = text_buffer.get_end_iter()
        Texte=text_buffer.get_text(start_iter, end_iter, include_hidden_chars=True)
        ecrire_codeprofessor(Texte)
        # création du fichier codesupp à partir du buffer
        text_buffer=self.textviewSupp.get_buffer()
        start_iter = text_buffer.get_start_iter()
        end_iter = text_buffer.get_end_iter()
        Texte=text_buffer.get_text(start_iter, end_iter, include_hidden_chars=True)
        ecrire_codesupp(Texte)  
        if self.radiobuttonMetapost.get_active()==True:
            ecrire_enteteprofessor("\\usepackage[xcas]{pro-2varstat}")  
            compiler("mp")
            self.Etat_Compilation=True
            afficher("mp","nuage1")
        else:
            ecrire_enteteprofessor("\\usepackage[xcas]{pro-asy-2varstat}")  
            compiler("asy")
            self.Etat_Compilation=True
            afficher("asy","nuage1")
        self.progressbar.set_text("")
        
            
    #-------------------------------------------------------------
    # Affichage du code graphique   
    #-------------------------------------------------------------  
    def on_buttonCodeGraphique_clicked(self,widget):
        if self.radiobuttonMetapost.get_active()==True: 
            afficher_codegraphique("mp","nuage1",self.Etat_Compilation)
        else:
            afficher_codegraphique("asy","nuage1",self.Etat_Compilation)

    #-------------------------------------------------------------
    # Affichage de l'image  
    #-------------------------------------------------------------  
    def on_buttonPdf_clicked(self,widget):
        if self.radiobuttonMetapost.get_active()==True: 
            afficher_imagepng("mp","nuage1",self.Etat_Compilation)
        else:
            afficher_imagepng("asy","nuage1",self.Etat_Compilation)         


            
#-------------------------------------------------------------          
#-------------------------------------------------------------      
# Boucle principale
#-------------------------------------------------------------
#-------------------------------------------------------------
if __name__ == "__main__":
    Nuage()
    gtk.main()

