# -*- coding:Utf-8 -*-
#!/usr/bin/python

# \copyleft Denis LE FUR \copyright
# This work may be distributed and/or mofified under the conditions
# or the LaTeX Project Public Licence, either v1.3 or (at your option)
# any later version. The latest version is in
#   http://www.latex-project.org/lppl/
# This work consists of the files bernoulli.py.


import pygtk
pygtk.require("2.0")
import gtk  

import os
import sys
import platform

if platform.system()=="Linux" :
    sys.path.append("../SystemeLinux/")
else :
    sys.path.append("../SystemeWindows/")
from pro_sortie import *


sys.path.append("../Divers/")
from pro_divers import *
sys.path.append("../Supplements/Pro-probas/")
from supp_bernoulli import *



class Bernoulli:


    #-------------------------------------------------------------
    # Initialisations, création de la fenêtre principale
    #-------------------------------------------------------------
    def __init__(self):
        interface = gtk.Builder()
        interface.add_from_file('bernoulli.glade')
        self.radiobuttonMetapost = interface.get_object("radiobuttonMetapost")
        self.radiobuttonAsymptote = interface.get_object("radiobuttonAsymptote")
        self.entryNomSucces = interface.get_object("entryNomSucces")
        self.entryNomEchec = interface.get_object("entryNomEchec")
        self.entryProbSucces = interface.get_object("entryProbSucces")
        self.radiobutton2 = interface.get_object("radiobutton2")
        self.radiobutton3 = interface.get_object("radiobutton3")
        self.radiobutton4 = interface.get_object("radiobutton4")
        self.buttonCompiler = interface.get_object("buttonCompiler")
        self.progressbar = interface.get_object("progressbar")
        self.buttonCodeGraphique = interface.get_object("buttonCodeGraphique")
        self.buttonPdf = interface.get_object("buttonPdf")
        self.textviewCodeProfessor = interface.get_object("textviewCodeProfessor")
        self.textviewSupp = interface.get_object("textviewSupp")
        self.labelEntete = interface.get_object("labelEntete")
        self.checkbuttonTitreGauche = interface.get_object("checkbuttonTitreGauche")
        self.checkbuttonTitreCentre = interface.get_object("checkbuttonTitreCentre")
        self.checkbuttonTitreDroite = interface.get_object("checkbuttonTitreDroite")
        self.entryTitreGauche = interface.get_object("entryTitreGauche")
        self.entryTitreCentre = interface.get_object("entryTitreCentre")
        self.entryTitreDroite = interface.get_object("entryTitreDroite")    
        
        #Indique si la compilation est lancée
        self.Etat_Compilation=False
        
        interface.connect_signals(self)
        self.maj_codeprofessor()
        maj_codesupp(self)
        
        self.textviewCodeProfessor.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse(couleurfond))
        self.textviewSupp.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse(couleurfond))

        self.entryTitreGauche.set_sensitive(False)
        self.entryTitreCentre.set_sensitive(False)
        self.entryTitreDroite.set_sensitive(False)
        


    #-------------------------------------------------------------  
    # Fin de l'application  
    #-------------------------------------------------------------
    def on_windowBernoulli_destroy(self, widget):
        gtk.main_quit()
        
    #-------------------------------------------------------------
    # Met à jour le code à insérer
    #-------------------------------------------------------------  
    def maj_codeprofessor(self):
        text_view=self.textviewCodeProfessor
        Texte_Code="\\begin{pro-bernoulli}{1}\n"
        Texte_Code=Texte_Code+"[\""
        NomSucces=self.entryNomSucces.get_text()
        NomSucces=NomSucces.replace('\\','@')
        NomEchec=self.entryNomEchec.get_text()
        NomEchec=NomEchec.replace('\\','@')
        ProbSucces=self.entryProbSucces.get_text()
        if self.radiobutton2.get_active()==True:
            NbRepetitions="2"
        elif self.radiobutton3.get_active()==True:
            NbRepetitions="3"
        else:
            NbRepetitions="4"   
        Texte_Code=Texte_Code+NomSucces+"\","+ProbSucces+",\""+NomEchec+"\"],\n"
        Texte_Code=Texte_Code+NbRepetitions+",\n"
        Texte_Code=Texte_Code+"// ----------------- début des options\n"
        Texte_Code=Texte_Code+"[\n"
        Options=self.traiter_options()
        Texte_Code=Texte_Code+Options
        Texte_Code=Texte_Code+"]\n"
        Texte_Code=Texte_Code+"// ----------------- fin des options\n"
        Texte_Code=Texte_Code+"\\end{pro-bernoulli}"
        ecrire_texte_textview(Texte_Code,text_view)




    #-------------------------------------------------------------
    # Mise à jour après des changements dans la définition de l'arbre
    #-------------------------------------------------------------      
    def on_entryNomSucces_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryNomEchec_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryProbSucces_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_radiobutton2_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_radiobutton3_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False

    def on_radiobutton4_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    #-------------------------------------------------------------
    # Mise à jour du label du nom de paquet à utiliser
    #-------------------------------------------------------------          
    def on_radiobuttonMetapost_clicked(self,widget):
        self.labelEntete.set_label("Placer dans l\'entête : \\usepackage[xcas]{pro-probas}")
        self.Etat_Compilation=False
        
    def on_radiobuttonAsymptote_clicked(self,widget):
        self.labelEntete.set_label("Placer dans l\'entête : \\usepackage[xcas]{pro-asy-probas}")
        self.Etat_Compilation=False     
        
        

    #-------------------------------------------------------------
    # Traitement des options de l'arbre     
    #-------------------------------------------------------------  
    def traiter_options(self):
        Options=""
        if self.checkbuttonTitreGauche.get_active()==True :
           Options="[\"titre-gauche\",\""
           TitreGauche=self.entryTitreGauche.get_text()
           TitreGauche=traiter_texte(TitreGauche)
           Options=Options+TitreGauche
           Options=Options+"\"],\n"
        if self.checkbuttonTitreCentre.get_active()==True :
           Options=Options+"[\"titre-centre\",\""
           TitreCentre=self.entryTitreCentre.get_text()
           TitreCentre=traiter_texte(TitreCentre)
           Options=Options+TitreCentre
           Options=Options+"\"],\n" 
        if self.checkbuttonTitreDroite.get_active()==True :
           Options=Options+"[\"titre-droite\",\""
           TitreDroite=self.entryTitreDroite.get_text()
           TitreDroite=traiter_texte(TitreDroite)
           Options=Options+TitreGauche

           Options=Options+"\"],\n"
        Options=Options+"[\"rien\"]\n"
        return Options

    #-------------------------------------------------------------
    # Mise à jour suite au traitement des options de l'arbre        
    #-------------------------------------------------------------          
    def on_checkbuttonTitreGauche_clicked(self,widget):
        if self.checkbuttonTitreGauche.get_active()==False :
            self.entryTitreGauche.set_sensitive(False)
        else :
            self.entryTitreGauche.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False

    def on_checkbuttonTitreCentre_clicked(self,widget):
        if self.checkbuttonTitreCentre.get_active()==False :
            self.entryTitreCentre.set_sensitive(False)
        else :
            self.entryTitreCentre.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False
            
    def on_checkbuttonTitreDroite_clicked(self,widget):
        if self.checkbuttonTitreDroite.get_active()==False :
            self.entryTitreDroite.set_sensitive(False)
        else :
            self.entryTitreDroite.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False
        
    def on_entryTitreGauche_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False

    def on_entryTitreCentre_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False 

    def on_entryTitreDroite_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False

    #-------------------------------------------------------------
    # lancement de la compilation   
    #-------------------------------------------------------------  
    def on_buttonTester_pressed(self,widget):
        self.progressbar.set_text("en cours...")
        
    def on_buttonTester_released(self,widget):
        # création du fichier codeprofessor à partir du buffer
        text_buffer=self.textviewCodeProfessor.get_buffer()
        start_iter = text_buffer.get_start_iter()
        end_iter = text_buffer.get_end_iter()
        Texte=text_buffer.get_text(start_iter, end_iter, include_hidden_chars=True)
        ecrire_codeprofessor(Texte)
        # création du fichier codesupp à partir du buffer
        text_buffer=self.textviewSupp.get_buffer()
        start_iter = text_buffer.get_start_iter()
        end_iter = text_buffer.get_end_iter()
        Texte=text_buffer.get_text(start_iter, end_iter, include_hidden_chars=True)
        ecrire_codesupp(Texte)  
        if self.radiobuttonMetapost.get_active()==True:
            ecrire_enteteprofessor("\\usepackage[xcas]{pro-probas}")    
            compiler("mp")
            self.Etat_Compilation=True
            afficher("mp","bernoulli1")
        else:
            ecrire_enteteprofessor("\\usepackage[xcas]{pro-asy-probas}")    
            compiler("asy")
            self.Etat_Compilation=True
            afficher("asy","bernoulli1")
        self.progressbar.set_text("")
            
    #-------------------------------------------------------------
    # Affichage du code graphique   
    #-------------------------------------------------------------  
    def on_buttonCodeGraphique_clicked(self,widget):
        if self.radiobuttonMetapost.get_active()==True: 
            afficher_codegraphique("mp","bernoulli1",self.Etat_Compilation)
        else:
            afficher_codegraphique("asy","bernoulli1",self.Etat_Compilation)

    #-------------------------------------------------------------
    # Affichage du code graphique   
    #-------------------------------------------------------------  
    def on_buttonPdf_clicked(self,widget):
        if self.radiobuttonMetapost.get_active()==True: 
            afficher_imagepng("mp","bernoulli1",self.Etat_Compilation)
        else:
            afficher_imagepng("asy","bernoulli1",self.Etat_Compilation)         


            
#-------------------------------------------------------------          
#-------------------------------------------------------------      
# Boucle principale
#-------------------------------------------------------------
#-------------------------------------------------------------
if __name__ == "__main__":
    Bernoulli()
    gtk.main()

