# -*- coding:Utf-8 -*-
#!/usr/bin/python

# \copyleft Denis LE FUR \copyright
# This work may be distributed and/or mofified under the conditions
# or the LaTeX Project Public Licence, either v1.3 or (at your option)
# any later version. The latest version is in
#   http://www.latex-project.org/lppl/
# This work consists of the files batonslabel.py.


import pygtk
pygtk.require("2.0")
import gtk  

import os
import sys
import platform

if platform.system()=="Linux" :
    sys.path.append("../SystemeLinux/")
else :
    sys.path.append("../SystemeWindows/")
from pro_sortie import *


sys.path.append("../Divers/")
from pro_divers import *
from textelibre import *
sys.path.append("../Supplements/Pro-statdiv/")
from supp_batonslabel import *





class Batonslabel:



    #-------------------------------------------------------------
    # Initialisations, création de la fenêtre principale
    #-------------------------------------------------------------
    def __init__(self):
        interface = gtk.Builder()
        interface.add_from_file('batonslabel.glade')
        self.initialisation=True
        self.radiobuttonMetapost = interface.get_object("radiobuttonMetapost")
        self.radiobuttonAsymptote = interface.get_object("radiobuttonAsymptote")
        self.entryListeLabels = interface.get_object("entryListeLabels")
        self.entryListeEffectifs = interface.get_object("entryListeEffectifs")
        self.entryYmin = interface.get_object("entryYmin")
        self.entryYmax = interface.get_object("entryYmax")
        self.entryUx = interface.get_object("entryUx")
        self.entryUy = interface.get_object("entryUy")
        self.entryLy = interface.get_object("entryLy")
        self.entryGy = interface.get_object("entryGy")
        self.entryTO = interface.get_object("entryTO")
        self.entryTA = interface.get_object("entryTA")
        self.entryNomPM = interface.get_object("entryNomPM")
        self.comboboxCD = interface.get_object("comboboxCD")    
        self.buttonCompiler = interface.get_object("buttonCompiler")
        self.progressbar = interface.get_object("progressbar")
        self.buttonCodeGraphique = interface.get_object("buttonCodeGraphique")
        self.buttonPdf = interface.get_object("buttonPdf")
        self.textviewCodeProfessor = interface.get_object("textviewCodeProfessor")
        self.textviewSupp = interface.get_object("textviewSupp")
        self.labelEntete = interface.get_object("labelEntete")
        self.checkbuttonTitreGauche = interface.get_object("checkbuttonTitreGauche")
        self.checkbuttonTitreCentre = interface.get_object("checkbuttonTitreCentre")
        self.checkbuttonTitreDroite = interface.get_object("checkbuttonTitreDroite")
        self.checkbuttonCouleurBoite = interface.get_object("checkbuttonCouleurBoite")
        self.checkbuttonCD = interface.get_object("checkbuttonCD")
        self.checkbuttonTO = interface.get_object("checkbuttonTO")
        self.checkbuttonTA = interface.get_object("checkbuttonTA")
        self.checkbuttonTexteLibre = interface.get_object("checkbuttonTexteLibre")
        self.entryTitreGauche = interface.get_object("entryTitreGauche")
        self.entryTitreCentre = interface.get_object("entryTitreCentre")
        self.entryTitreDroite = interface.get_object("entryTitreDroite")    

        
        #Indique si la compilation est lancée
        self.Etat_Compilation=False
        
        #fenêtre textlibre
        self.TL=Textelibre(self)
        self.TL.windowTL.set_title("Textes supplémentaires")
        self.TL.windowTL.hide()
        
        
        interface.connect_signals(self)
        self.maj_codeprofessor()
        maj_codesupp(self)
        
        #Couleur par défaut : orange
        self.comboboxCD.set_active(4)

        
        #désactivation
        self.comboboxCD.set_sensitive(False)
        self.entryTO.set_sensitive(False)
        self.entryTA.set_sensitive(False)

        
        self.textviewCodeProfessor.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse(couleurfond))
        self.textviewSupp.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse(couleurfond))

        self.entryTitreGauche.set_sensitive(False)
        self.entryTitreCentre.set_sensitive(False)
        self.entryTitreDroite.set_sensitive(False)
        
        self.initialisation=False


    #-------------------------------------------------------------  
    # Fin de l'application  
    #-------------------------------------------------------------
    def on_windowBatonslabel_destroy(self, widget):
        gtk.main_quit()

    #-------------------------------------------------------------
    # Met à jour le code à insérer
    #-------------------------------------------------------------  
    def maj_codeprofessor(self):
        text_view=self.textviewCodeProfessor
        Texte_Code="\\begin{pro-batonslabel}{1}\n"
        Texte_Code=Texte_Code+"["
        ListeLabels=self.entryListeLabels.get_text()
        ListeLabels=traiter_texte(ListeLabels)
        ListeEffectifs=self.entryListeEffectifs.get_text()
        ListeEffectifs=ListeEffectifs.replace('\\','@')
        Ymin=self.entryYmin.get_text()
        Ymin=Ymin.replace('\\','@')
        Ymax=self.entryYmax.get_text()
        Ymax=Ymax.replace('\\','@')
        Ux=self.entryUx.get_text()
        Ux=Ux.replace('\\','@')
        Uy=self.entryUy.get_text()
        Uy=Uy.replace('\\','@')
        Ly=self.entryLy.get_text()
        Ly=Ly.replace('\\','@')
        Gy=self.entryGy.get_text()
        Gy=Gy.replace('\\','@') 
        Texte_Code=Texte_Code+ListeLabels+"],\n"
        Texte_Code=Texte_Code+"["+ListeEffectifs+"],\n"
        Texte_Code=Texte_Code+Ymin+","+Ymax+",\n"
        Texte_Code=Texte_Code+Ux+","+Uy+",\n"
        Texte_Code=Texte_Code+Ly+",\n"
        Texte_Code=Texte_Code+Gy+",\n"
        Texte_Code=Texte_Code+"// ----------------- début des options\n"
        Texte_Code=Texte_Code+"[\n"
        Options=self.traiter_options()
        Texte_Code=Texte_Code+Options
        Texte_Code=Texte_Code+"]\n"
        Texte_Code=Texte_Code+"// ----------------- fin des options\n"
        Texte_Code=Texte_Code+"\\end{pro-batonslabel}"
        ecrire_texte_textview(Texte_Code,text_view)




    #-------------------------------------------------------------
    # Mise à jour après des changements dans la définition
    #-------------------------------------------------------------      
    def on_entryListeLabels_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryListeEffectifs_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryYmin_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryYmax_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False 
        
    def on_entryUx_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryUy_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False 
        
    def on_entryLy_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryGy_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)  
        self.Etat_Compilation=False 

    def on_checkbuttonCD_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonCD.get_active()==True:
            self.comboboxCD.set_sensitive(True)
        else:
            self.comboboxCD.set_sensitive(False)
        self.Etat_Compilation=False
        
    def on_checkbuttonTO_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonTO.get_active()==True:
            self.entryTO.set_sensitive(True)
        else:
            self.entryTO.set_sensitive(False)
        self.Etat_Compilation=False 
        
    def on_checkbuttonTA_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonTA.get_active()==True:
            self.entryTA.set_sensitive(True)
        else:
            self.entryTO.set_sensitive(False)
        self.Etat_Compilation=False 

    def on_checkbuttonTexteLibre_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonTexteLibre.get_active()==True:
            self.TL.windowTL.show_all()
        else:
            self.TL.windowTL.hide()
        self.Etat_Compilation=False
        


    #-------------------------------------------------------------
    # Mise à jour du label du nom de paquet à utiliser
    #-------------------------------------------------------------          
    def on_radiobuttonMetapost_clicked(self,widget):
        self.labelEntete.set_label("Placer dans l\'entête : \\usepackage[xcas]{pro-statdiv}")
        self.Etat_Compilation=False
        
    def on_radiobuttonAsymptote_clicked(self,widget):
        self.labelEntete.set_label("Placer dans l\'entête : \\usepackage[xcas]{pro-asy-statdiv}")       
        self.Etat_Compilation=False
        

    #-------------------------------------------------------------
    # Traitement des options    
    #-------------------------------------------------------------  
    def traiter_options(self):
        Options=""
        if self.checkbuttonTitreGauche.get_active()==True :
           Options="[\"titre-gauche\",\""
           TitreGauche=self.entryTitreGauche.get_text()
           TitreGauche=traiter_texte(TitreGauche)
           Options=Options+TitreGauche
           Options=Options+"\"],\n"
           
        if self.checkbuttonTitreCentre.get_active()==True :
           Options=Options+"[\"titre-centre\",\""
           TitreCentre=self.entryTitreCentre.get_text()
           TitreCentre=traiter_texte(TitreCentre)
           Options=Options+TitreCentre
           Options=Options+"\"],\n" 
           
        if self.checkbuttonTitreDroite.get_active()==True :
           Options=Options+"[\"titre-droite\",\""
           TitreDroite=self.entryTitreDroite.get_text()
           TitreDroite=traiter_texte(TitreDroite)
           Options=Options+TitreGauche
           
        if self.checkbuttonCD.get_active()==True :
            Couleur=self.comboboxCD.get_active_text()
            Couleur=Nom_Couleur(Couleur)
            Options=Options+"[\"couleur-dessin\",\""
            Options=Options+Couleur
            Options=Options+"\"],\n"  
            
        if self.checkbuttonTO.get_active()==True :
            TO=self.entryTO.get_text()
            TO=traiter_texte(TO)
            Options=Options+"[\"texte-ordonnees\",\""
            Options=Options+TO
            Options=Options+"\"],\n" 
            
        if self.checkbuttonTA.get_active()==True :
            TA=self.entryTA.get_text()
            TA=traiter_texte(TA)
            Options=Options+"[\"texte-abscisses\",\""
            Options=Options+TA
            Options=Options+"\"],\n"    
               
        Options=Options+self.TL.Texte_Libre
        Options=Options+"[\"rien\"]\n"
        return Options

    #-------------------------------------------------------------
    # Mise à jour suite au traitement des options   
    #-------------------------------------------------------------          
    def on_checkbuttonTitreGauche_clicked(self,widget):
        if self.checkbuttonTitreGauche.get_active()==False :
            self.entryTitreGauche.set_sensitive(False)
        else :
            self.entryTitreGauche.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False

    def on_checkbuttonTitreCentre_clicked(self,widget):
        if self.checkbuttonTitreCentre.get_active()==False :
            self.entryTitreCentre.set_sensitive(False)
        else :
            self.entryTitreCentre.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False
            
    def on_checkbuttonTitreDroite_clicked(self,widget):
        if self.checkbuttonTitreDroite.get_active()==False :
            self.entryTitreDroite.set_sensitive(False)
        else :
            self.entryTitreDroite.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False
        
    def on_entryTitreGauche_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False

    def on_entryTitreCentre_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False 

    def on_entryTitreDroite_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False
        
    def on_comboboxCD_changed(self,widget): 
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False 
            
    def on_entryTO_changed(self,widget):    
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False 
        
    def on_entryTA_changed(self,widget):    
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False     
        
        

    #-------------------------------------------------------------
    # lancement de la compilation   
    #-------------------------------------------------------------  
    def on_buttonTester_pressed(self,widget):
        self.progressbar.set_text("en cours...")
        
    def on_buttonTester_released(self,widget):
        # création du fichier codeprofessor à partir du buffer
        text_buffer=self.textviewCodeProfessor.get_buffer()
        start_iter = text_buffer.get_start_iter()
        end_iter = text_buffer.get_end_iter()
        Texte=text_buffer.get_text(start_iter, end_iter, include_hidden_chars=True)
        ecrire_codeprofessor(Texte)
        # création du fichier codesupp à partir du buffer
        text_buffer=self.textviewSupp.get_buffer()
        start_iter = text_buffer.get_start_iter()
        end_iter = text_buffer.get_end_iter()
        Texte=text_buffer.get_text(start_iter, end_iter, include_hidden_chars=True)
        ecrire_codesupp(Texte)  
        if self.radiobuttonMetapost.get_active()==True:
            ecrire_enteteprofessor("\\usepackage[xcas]{pro-statdiv}")   
            compiler("mp")
            self.Etat_Compilation=True
            afficher("mp","batonslabel1")
        else:
            ecrire_enteteprofessor("\\usepackage[xcas]{pro-asy-statdiv}")   
            compiler("asy")
            self.Etat_Compilation=True
            afficher("asy","batonslabel1")
        self.progressbar.set_text("")
        
            
    #-------------------------------------------------------------
    # Affichage du code graphique   
    #-------------------------------------------------------------  
    def on_buttonCodeGraphique_clicked(self,widget):
        if self.radiobuttonMetapost.get_active()==True: 
            afficher_codegraphique("mp","batonslabel1",self.Etat_Compilation)
        else:
            afficher_codegraphique("asy","batonslabel1",self.Etat_Compilation)

    #-------------------------------------------------------------
    # Affichage de l'image  
    #-------------------------------------------------------------  
    def on_buttonPdf_clicked(self,widget):
        if self.radiobuttonMetapost.get_active()==True: 
            afficher_imagepng("mp","batonslabel1",self.Etat_Compilation)
        else:
            afficher_imagepng("asy","batonslabel1",self.Etat_Compilation)           


            
#-------------------------------------------------------------          
#-------------------------------------------------------------      
# Boucle principale
#-------------------------------------------------------------
#-------------------------------------------------------------
if __name__ == "__main__":
    Batonslabel()
    gtk.main()

